/* ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : DMACH1.c
**     Project     : K60_1M_UART_DMA
**     Processor   : MK60FN1M0VLQ12
**     Component   : DMAChannel_LDD
**     Version     : Component 01.051, Driver 01.00, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2014-04-10, 16:12, # CodeGen: 15
**     Abstract    :
**          This embedded component implements
**          a DMA transfer channel descriptor definition.
**     Settings    :
**          Component name                                 : DMACH1
**          Request source                                 : UART0_Receive_DMA_Request
**          Channel select                                 : Fixed
**            DMA controller device                        : DMA1
**            Channel                                      : DMA_Channel0
**            Allocate channel                             : yes
**            Periodic trigger                             : Disabled
**            Arbitration type                             : Fixed
**              Priority                                   : 0
**            Interrupt service                            : Enabled
**              Transfer complete interrupt                : 
**                Interrupt vector                         : INT_DMA0_DMA16
**                Interrupt priority                       : 8
**              Error interrupt                            : 
**                Interrupt vector                         : INT_DMA_Error
**                Interrupt priority                       : medium priority
**          External object declaration                    : (string list)
**          Source transaction settings                    : 
**            Start address                                : &UART0_D
**            Transaction size                             : 8-bits
**            Address adjustment                           : 0
**            Address modulo                               : Buffer disabled
**          Destination transaction settings               : 
**            Start address                                : &buffer
**            Transaction size                             : 8-bits
**            Address adjustment                           : 1
**            Address modulo                               : Buffer disabled
**          Transfer settings                              : 
**            Bandwidth control                            : No stalls
**            Transaction size                             : 8-bits
**            Transactions count                           : 1
**            Request count                                : 8
**            After request complete actions               : 
**              Channel linking                            : Disabled
**              Address adjustment                         : Disabled
**            After transfer complete actions              : 
**              Disable peripheral request                 : no
**              Channel linking                            : Disabled
**              Address adjustment                         : Disabled
**              Scatter/gather                             : Disabled
**          Initialization                                 : 
**            Enabled in init. code                        : yes
**            Auto initialization                          : no
**            Half complete                                : Disabled
**            Event mask                                   : 
**              OnComplete                                 : Enabled
**              OnError                                    : Enabled
**     Contents    :
**         Init            - LDD_TDeviceData* DMACH1_Init(LDD_TUserData *UserDataPtr);
**         EnableRequest   - LDD_TError DMACH1_EnableRequest(LDD_TDeviceData *DeviceDataPtr);
**         GetError        - LDD_DMA_TErrorFlags DMACH1_GetError(LDD_TDeviceData *DeviceDataPtr);
**         SetRequestCount - LDD_TError DMACH1_SetRequestCount(LDD_TDeviceData *DeviceDataPtr,...
**
**     Copyright : 1997 - 2013 Freescale Semiconductor, Inc. All Rights Reserved.
**     SOURCE DISTRIBUTION PERMISSIBLE as directed in End User License Agreement.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/
/*!
** @file DMACH1.c
** @version 01.00
** @brief
**          This embedded component implements
**          a DMA transfer channel descriptor definition.
*/         
/*!
**  @addtogroup DMACH1_module DMACH1 module documentation
**  @{
*/         

/* MODULE DMACH1. */

#include "Events.h"
#include "DMACH1.h"
/* {Default RTOS Adapter} No RTOS includes */

#define DMACH1_INIT_EVENTS_MASK ((LDD_TEventMask)( \
          LDD_DMA_ON_COMPLETE | \
          LDD_DMA_ON_ERROR))

/* This code is generated from External object declaration property */
extern unsigned char buffer[32];

/* Channel configuration structure */
DMA1_TChnInit const DMACH1_ChInit = {
  /* Logical channel number */
  DMA1_STATIC_CHANNEL_0,               /* Phy channel: DMA_Channel0 */
  { /* TCD initial settings */
    DMA_SADDR_SADDR(0x00),             /* Initial value is not constant expresion. See Init() method to see initial value. */
    DMA_SOFF_SOFF(0x00),               /* TCD_SOFF register initial value */
    ( DMA_ATTR_SMOD(0x00) |
      DMA_ATTR_SSIZE(0x00) |
      DMA_ATTR_DMOD(0x00) |
      DMA_ATTR_DSIZE(0x00)
    ),                                 /* TCD_ATTR register initial value */
    DMA_NBYTES_MLNO_NBYTES(0x01),      /* TCD_NBYTES_MLNO register initial value */
    DMA_SLAST_SLAST(0x00),             /* TCD_SLAST register initial value */
    DMA_DADDR_DADDR(0x00),             /* Initial value is not constant expresion. See Init() method to see initial value. */
    DMA_DOFF_DOFF(0x01),               /* TCD_DOFF register initial value */
    (DMA_CITER_ELINKYES_LINKCH(0x00) | DMA_CITER_ELINKYES_CITER(0x08)), /* TCD_CITER_ELINKYES register initial value */
    DMA_DLAST_SGA_DLASTSGA(0x00),      /* TCD_DLASTSGA register initial value */
    (DMA_CSR_BWC(0x00) | DMA_CSR_MAJORLINKCH(0x00) | DMA_CSR_INTMAJOR_MASK), /* TCD_CSR register initial value */
    (DMA_BITER_ELINKYES_LINKCH(0x00) | DMA_BITER_ELINKYES_BITER(0x08)) /* TCD_BITER_ELINKYES register initial value */
  },
  /* DMAMUX initial settings */
  (DMAMUX_CHCFG_ENBL_MASK | DMAMUX_CHCFG_SOURCE(0x02)), /* DMA multiplexor configuration register initial value 'UART0_Receive_DMA_Request' */
  { /* Events initial setting */
    &DMACH1_OnComplete,                /* OnComplete callback address */
    &DMACH1_OnError                    /* OnComplete callback address */
  }
};

/*
** ===================================================================
**     Method      :  DMACH1_Init (component DMAChannel_LDD)
*/
/*!
**     @brief
**         Initializes the DMAChannel_LDD component. This method
**         allocates no memory. Memory for all DMA used channles is
**         allocated by DMAController componet .
**         This method can be called only once. Before the second call
**         of Init() the Deinit() must be called first.
**     @param
**         UserDataPtr     - Pointer to the user or
**                           RTOS specific data. This pointer will be
**                           passed as an event or callback parameter.
**     @return
**                         - Device data structure pointer.
*/
/* ===================================================================*/
LDD_TDeviceData* DMACH1_Init(LDD_TUserData *UserDataPtr)
{
  LDD_TDeviceData                 *DevDataPtr; /* DMA device data structure pointer */
  LDD_TDeviceData                 *ChnDevDataPtr; /* DMA channel device data structure pointer */
  DMA1_TChnInit                    ChnInit;

  DevDataPtr = PE_LDD_DeviceDataList[PE_LDD_COMPONENT_DMA1_ID]; /* Get DMA peripheral handle */
  if (DevDataPtr == NULL) {            /* Is DMA peripheral initialized? */
    DevDataPtr = DMA1_Init();          /* No, try to initialize it */
    if (DevDataPtr == NULL) {          /* initialization failed? */
      return NULL;                     /* Yes, return NULL */
    }
  }
  ChnInit = DMACH1_ChInit;             /* Initialize local copy of init. structure */
  ChnInit.TCD.DMA_TCD_SADDR_Reg = DMA_SADDR_SADDR(&UART0_D); /* TCD_SADDR register initial value */
  ChnInit.TCD.DMA_TCD_DADDR_Reg = DMA_DADDR_DADDR(&buffer); /* TCD_DADDR register initial value */
  /* Initialize DMA channel device and get DMA channel handle */
  ChnDevDataPtr = DMA1_InitChannel(DevDataPtr, (DMA1_TChnInit *)(void *)&ChnInit, UserDataPtr);
  /* Registration of the device structure */
  PE_LDD_RegisterDeviceStructure(PE_LDD_COMPONENT_DMACH1_ID,ChnDevDataPtr);
  /* Return pointer to the channel data structure */
  return (ChnDevDataPtr);
}

/*
** ===================================================================
**     Method      :  DMACH1_EnableRequest (component DMAChannel_LDD)
*/
/*!
**     @brief
**         The method enables request from peripheral. Please note that
**         this method doesn't start the transfer. The transfer is
**         started as soon as DMA request from peripheral is asserted.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @return
**                         - Error code, possible codes: 
**                           - ERR_OK - OK. 
**                           - ERR_DISABLED - Component is disabled.
*/
/* ===================================================================*/
LDD_TError DMACH1_EnableRequest(LDD_TDeviceData *DeviceDataPtr)
{
  return DMA1_EnableRequest((DMA1_TChanDeviceData *)DeviceDataPtr);
}

/*
** ===================================================================
**     Method      :  DMACH1_GetError (component DMAChannel_LDD)
*/
/*!
**     @brief
**         Returns channel error flags and clears these flags. 
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @return
**                         - DMA Error flags.
*/
/* ===================================================================*/
LDD_DMA_TErrorFlags DMACH1_GetError(LDD_TDeviceData *DeviceDataPtr)
{
  return DMA1_GetError((DMA1_TChanDeviceData *)DeviceDataPtr);
}

/*
** ===================================================================
**     Method      :  DMACH1_SetRequestCount (component DMAChannel_LDD)
*/
/*!
**     @brief
**         Sets number of requests required to complete transfer.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         RequestCount    - Number of requests
**                           required to complete transfer.
**     @return
**                         - Error code, possible codes: 
**                           - ERR_OK - OK. 
**                           - ERR_DISABLED - Component is disabled.
*/
/* ===================================================================*/
LDD_TError DMACH1_SetRequestCount(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TRequestCount RequestCount)
{
  return DMA1_SetRequestCount((DMA1_TChanDeviceData *)DeviceDataPtr, RequestCount);
}

/* END DMACH1. */

/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.08]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
