/* ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : DMACH1.h
**     Project     : K60_1M_UART_DMA
**     Processor   : MK60FN1M0VLQ12
**     Component   : DMAChannel_LDD
**     Version     : Component 01.051, Driver 01.00, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2014-04-10, 16:12, # CodeGen: 15
**     Abstract    :
**          This embedded component implements
**          a DMA transfer channel descriptor definition.
**     Settings    :
**          Component name                                 : DMACH1
**          Request source                                 : UART0_Receive_DMA_Request
**          Channel select                                 : Fixed
**            DMA controller device                        : DMA1
**            Channel                                      : DMA_Channel0
**            Allocate channel                             : yes
**            Periodic trigger                             : Disabled
**            Arbitration type                             : Fixed
**              Priority                                   : 0
**            Interrupt service                            : Enabled
**              Transfer complete interrupt                : 
**                Interrupt vector                         : INT_DMA0_DMA16
**                Interrupt priority                       : 8
**              Error interrupt                            : 
**                Interrupt vector                         : INT_DMA_Error
**                Interrupt priority                       : medium priority
**          External object declaration                    : (string list)
**          Source transaction settings                    : 
**            Start address                                : &UART0_D
**            Transaction size                             : 8-bits
**            Address adjustment                           : 0
**            Address modulo                               : Buffer disabled
**          Destination transaction settings               : 
**            Start address                                : &buffer
**            Transaction size                             : 8-bits
**            Address adjustment                           : 1
**            Address modulo                               : Buffer disabled
**          Transfer settings                              : 
**            Bandwidth control                            : No stalls
**            Transaction size                             : 8-bits
**            Transactions count                           : 1
**            Request count                                : 8
**            After request complete actions               : 
**              Channel linking                            : Disabled
**              Address adjustment                         : Disabled
**            After transfer complete actions              : 
**              Disable peripheral request                 : no
**              Channel linking                            : Disabled
**              Address adjustment                         : Disabled
**              Scatter/gather                             : Disabled
**          Initialization                                 : 
**            Enabled in init. code                        : yes
**            Auto initialization                          : no
**            Half complete                                : Disabled
**            Event mask                                   : 
**              OnComplete                                 : Enabled
**              OnError                                    : Enabled
**     Contents    :
**         Init            - LDD_TDeviceData* DMACH1_Init(LDD_TUserData *UserDataPtr);
**         EnableRequest   - LDD_TError DMACH1_EnableRequest(LDD_TDeviceData *DeviceDataPtr);
**         GetError        - LDD_DMA_TErrorFlags DMACH1_GetError(LDD_TDeviceData *DeviceDataPtr);
**         SetRequestCount - LDD_TError DMACH1_SetRequestCount(LDD_TDeviceData *DeviceDataPtr,...
**
**     Copyright : 1997 - 2013 Freescale Semiconductor, Inc. All Rights Reserved.
**     SOURCE DISTRIBUTION PERMISSIBLE as directed in End User License Agreement.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/
/*!
** @file DMACH1.h
** @version 01.00
** @brief
**          This embedded component implements
**          a DMA transfer channel descriptor definition.
*/         
/*!
**  @addtogroup DMACH1_module DMACH1 module documentation
**  @{
*/         

#ifndef __DMACH1_H
#define __DMACH1_H

/* MODULE DMACH1. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "DMA1.h"
#include "PE_LDD.h"
#include "DMA_PDD.h"

#include "Cpu.h"

/*! Peripheral base address of a device allocated by the component. This constant can be used directly in PDD macros. */
#define DMACH1_PRPH_BASE_ADDRESS  0x40008000U
  
/* Methods configuration constants - generated for all enabled component's methods */
#define DMACH1_Init_METHOD_ENABLED     /*!< Init method of the component DMACH1 is enabled (generated) */
#define DMACH1_EnableRequest_METHOD_ENABLED /*!< EnableRequest method of the component DMACH1 is enabled (generated) */
#define DMACH1_GetError_METHOD_ENABLED /*!< GetError method of the component DMACH1 is enabled (generated) */
#define DMACH1_SetRequestCount_METHOD_ENABLED /*!< SetRequestCount method of the component DMACH1 is enabled (generated) */

/* Events configuration constants - generated for all enabled component's events */
#define DMACH1_OnComplete_EVENT_ENABLED /*!< OnComplete event of the component DMACH1 is enabled (generated) */
#define DMACH1_OnError_EVENT_ENABLED   /*!< OnError event of the component DMACH1 is enabled (generated) */

/* Source circular buffer base address mask. Represents required 0-modulo-size mask of base source address when using circular buffer. */
#define DMACH1_SOURCE_CIRCULAR_BUFFER_ADDRESS_MASK 0U
/* Destination circular buffer base address mask. Represents required 0-modulo-size mask of base destination address when using circular buffer. */
#define DMACH1_DESTINATION_CIRCULAR_BUFFER_ADDRESS_MASK 0U

/*
** ===================================================================
**     Method      :  DMACH1_Init (component DMAChannel_LDD)
*/
/*!
**     @brief
**         Initializes the DMAChannel_LDD component. This method
**         allocates no memory. Memory for all DMA used channles is
**         allocated by DMAController componet .
**         This method can be called only once. Before the second call
**         of Init() the Deinit() must be called first.
**     @param
**         UserDataPtr     - Pointer to the user or
**                           RTOS specific data. This pointer will be
**                           passed as an event or callback parameter.
**     @return
**                         - Device data structure pointer.
*/
/* ===================================================================*/
LDD_TDeviceData* DMACH1_Init(LDD_TUserData *UserDataPtr);

/*
** ===================================================================
**     Method      :  DMACH1_EnableRequest (component DMAChannel_LDD)
*/
/*!
**     @brief
**         The method enables request from peripheral. Please note that
**         this method doesn't start the transfer. The transfer is
**         started as soon as DMA request from peripheral is asserted.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @return
**                         - Error code, possible codes: 
**                           - ERR_OK - OK. 
**                           - ERR_DISABLED - Component is disabled.
*/
/* ===================================================================*/
LDD_TError DMACH1_EnableRequest(LDD_TDeviceData *DeviceDataPtr);

/*
** ===================================================================
**     Method      :  DMACH1_GetError (component DMAChannel_LDD)
*/
/*!
**     @brief
**         Returns channel error flags and clears these flags. 
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @return
**                         - DMA Error flags.
*/
/* ===================================================================*/
LDD_DMA_TErrorFlags DMACH1_GetError(LDD_TDeviceData *DeviceDataPtr);

/*
** ===================================================================
**     Method      :  DMACH1_SetRequestCount (component DMAChannel_LDD)
*/
/*!
**     @brief
**         Sets number of requests required to complete transfer.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         RequestCount    - Number of requests
**                           required to complete transfer.
**     @return
**                         - Error code, possible codes: 
**                           - ERR_OK - OK. 
**                           - ERR_DISABLED - Component is disabled.
*/
/* ===================================================================*/
LDD_TError DMACH1_SetRequestCount(LDD_TDeviceData *DeviceDataPtr, LDD_DMA_TRequestCount RequestCount);

/* END DMACH1. */
#endif
/* ifndef __DMACH1_H */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.08]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
