/* ###################################################################
**     Filename    : main.c
**     Project     : K60_1M_UART_DMA
**     Processor   : MK60FN1M0VLQ12
**     Version     : Driver 01.01
**     Compiler    : GNU C Compiler
**     Date/Time   : 2014-04-03, 14:34, # CodeGen: 1
**     Abstract    :
**         Main module.
**         This module contains user's application code.
**     Settings    :
**     Contents    :
**         No public methods
**
**     Copyright Freescale Semiconductor, Inc. All Rights Reserved.
** ###################################################################*/
/*!
** @file main.c
** @version 01.01
** @brief
**         Main module.
**         This module contains user's application code.
*/         
/*!
**  @addtogroup main_module main module documentation
**  @{
*/         
/* MODULE main */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "AS1.h"
#include "DMACH1.h"
#include "DMA1.h"
/* Including shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* User includes (#include below this line is not maintained by Processor Expert) */
#include "UART_PDD.h"

unsigned char buffer[8];
volatile bool blockSent = FALSE;
volatile bool dmaComplete = FALSE;

/*lint -save  -e970 Disable MISRA rule (6.3) checking. */
int main(void)
/*lint -restore Enable MISRA rule (6.3) checking. */
{
  /* Write your local variable definition here */
  char data[] = "abcdefgh";
  LDD_TError Error;
  LDD_TDeviceData *dd_serial;
  LDD_TDeviceData *dd_dma;
  
  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/
  
  //component init
  dd_dma = DMACH1_Init(NULL);
  dd_serial = AS1_Init(NULL);
  
  
  UART_PDD_EnableReceiveDma(UART0_BASE_PTR, PDD_ENABLE); //enable DMA on uart receiver
  DMACH1_EnableRequest(dd_dma); //enable dma request
  
  
  Error = AS1_SendBlock(dd_serial, data, sizeof(data)); 
  while (blockSent == FALSE) ;
  blockSent = FALSE;
  
  while (dmaComplete == FALSE) ; //wait for DMA complete interrupt (see events.h)
  
  
  //here we have transfer complete. check the buffer variable
  for(;;) {}

  /*** Don't write any code pass this line, or it will be deleted during code generation. ***/
  /*** RTOS startup code. Macro PEX_RTOS_START is defined by the RTOS component. DON'T MODIFY THIS CODE!!! ***/
  #ifdef PEX_RTOS_START
    PEX_RTOS_START();                  /* Startup of the selected RTOS. Macro is defined by the RTOS component. */
  #endif
  /*** End of RTOS startup code.  ***/
  /*** Processor Expert end of main routine. DON'T MODIFY THIS CODE!!! ***/
  for(;;){}
  /*** Processor Expert end of main routine. DON'T WRITE CODE BELOW!!! ***/
} /*** End of main routine. DO NOT MODIFY THIS TEXT!!! ***/

/* END main */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 0.00.00 [05.09]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
 
